# cython: language_level=3

# Client
cdef:
    int CLIENT_LONG_PASSWORD, CLIENT_FOUND_ROWS, CLIENT_LONG_FLAG, CLIENT_CONNECT_WITH_DB
    int CLIENT_NO_SCHEMA, CLIENT_COMPRESS, CLIENT_ODBC, CLIENT_LOCAL_FILES, CLIENT_IGNORE_SPACE
    int CLIENT_PROTOCOL_41, CLIENT_INTERACTIVE, CLIENT_SSL, CLIENT_IGNORE_SIGPIPE
    int CLIENT_TRANSACTIONS, CLIENT_SECURE_CONNECTION, CLIENT_MULTI_STATEMENTS
    int CLIENT_MULTI_RESULTS, CLIENT_PS_MULTI_RESULTS, CLIENT_PLUGIN_AUTH, CLIENT_CONNECT_ATTRS
    int CLIENT_PLUGIN_AUTH_LENENC_CLIENT_DATA, CLIENT_CAPABILITIES, CLIENT_HANDLE_EXPIRED_PASSWORDS
    int CLIENT_SESSION_TRACK, CLIENT_DEPRECATE_EOF

# Command
cdef:
    int COM_SLEEP, COM_QUIT, COM_INIT_DB, COM_QUERY, COM_FIELD_LIST
    int COM_CREATE_DB, COM_DROP_DB, COM_REFRESH, COM_SHUTDOWN
    int COM_STATISTICS, COM_PROCESS_INFO, COM_CONNECT, COM_PROCESS_KILL
    int COM_DEBUG, COM_PING, COM_TIME, COM_DELAYED_INSERT, COM_CHANGE_USER
    int COM_BINLOG_DUMP, COM_TABLE_DUMP, COM_CONNECT_OUT, COM_REGISTER_SLAVE
    int COM_STMT_PREPARE, COM_STMT_EXECUTE, COM_STMT_SEND_LONG_DATA
    int COM_STMT_CLOSE, COM_STMT_RESET, COM_SET_OPTION, COM_STMT_FETCH
    int COM_DAEMON, COM_BINLOG_DUMP_GTID, COM_END

# CR
cdef:
    int CR_ERROR_FIRST, CR_UNKNOWN_ERROR, CR_SOCKET_CREATE_ERROR, CR_CONNECTION_ERROR
    int CR_CONN_HOST_ERROR, CR_IPSOCK_ERROR, CR_UNKNOWN_HOST, CR_SERVER_GONE_ERROR
    int CR_VERSION_ERROR, CR_OUT_OF_MEMORY, CR_WRONG_HOST_INFO, CR_LOCALHOST_CONNECTION
    int CR_TCP_CONNECTION, CR_SERVER_HANDSHAKE_ERR, CR_SERVER_LOST, CR_COMMANDS_OUT_OF_SYNC
    int CR_NAMEDPIPE_CONNECTION, CR_NAMEDPIPEWAIT_ERROR, CR_NAMEDPIPEOPEN_ERROR
    int CR_NAMEDPIPESETSTATE_ERROR, CR_CANT_READ_CHARSET, CR_NET_PACKET_TOO_LARGE
    int CR_EMBEDDED_CONNECTION, CR_PROBE_SLAVE_STATUS, CR_PROBE_SLAVE_HOSTS
    int CR_PROBE_SLAVE_CONNECT, CR_PROBE_MASTER_CONNECT, CR_SSL_CONNECTION_ERROR
    int CR_MALFORMED_PACKET, CR_WRONG_LICENSE, CR_NULL_POINTER, CR_NO_PREPARE_STMT
    int CR_PARAMS_NOT_BOUND, CR_DATA_TRUNCATED, CR_NO_PARAMETERS_EXISTS
    int CR_INVALID_PARAMETER_NO, CR_INVALID_BUFFER_USE, CR_UNSUPPORTED_PARAM_TYPE
    int CR_SHARED_MEMORY_CONNECTION, CR_SHARED_MEMORY_CONNECT_REQUEST_ERROR
    int CR_SHARED_MEMORY_CONNECT_ANSWER_ERROR, CR_SHARED_MEMORY_CONNECT_FILE_MAP_ERROR
    int CR_SHARED_MEMORY_CONNECT_MAP_ERROR, CR_SHARED_MEMORY_FILE_MAP_ERROR
    int CR_SHARED_MEMORY_MAP_ERROR, CR_SHARED_MEMORY_EVENT_ERROR
    int CR_SHARED_MEMORY_CONNECT_ABANDONED_ERROR, CR_SHARED_MEMORY_CONNECT_SET_ERROR
    int CR_CONN_UNKNOW_PROTOCOL, CR_INVALID_CONN_HANDLE, CR_SECURE_AUTH, CR_FETCH_CANCELED
    int CR_NO_DATA, CR_NO_STMT_METADATA, CR_NO_RESULT_SET, CR_NOT_IMPLEMENTED
    int CR_SERVER_LOST_EXTENDED, CR_STMT_CLOSED, CR_NEW_STMT_METADATA, CR_ALREADY_CONNECTED
    int CR_AUTH_PLUGIN_CANNOT_LOAD, CR_DUPLICATE_CONNECTION_ATTR, CR_AUTH_PLUGIN_ERR
    int CR_INSECURE_API_ERR, CR_FILE_NAME_TOO_LONG, CR_SSL_FIPS_MODE_ERR
    int CR_DEPRECATED_COMPRESSION_NOT_SUPPORTED, CR_COMPRESSION_WRONGLY_CONFIGURED
    int CR_KERBEROS_USER_NOT_FOUND, CR_LOAD_DATA_LOCAL_INFILE_REJECTED
    int CR_LOAD_DATA_LOCAL_INFILE_REALPATH_FAIL, CR_DNS_SRV_LOOKUP_FAILED
    int CR_MANDATORY_TRACKER_NOT_FOUND, CR_INVALID_FACTOR_NO, CR_ERROR_LAST

# ER
cdef:
    int ER_ERROR_FIRST, ER_HASHCHK, ER_NISAMCHK, ER_NO, ER_YES, ER_CANT_CREATE_FILE
    int ER_CANT_CREATE_TABLE, ER_CANT_CREATE_DB, ER_DB_CREATE_EXISTS, ER_DB_DROP_EXISTS
    int ER_DB_DROP_DELETE, ER_DB_DROP_RMDIR, ER_CANT_DELETE_FILE, ER_CANT_FIND_SYSTEM_REC
    int ER_CANT_GET_STAT, ER_CANT_GET_WD, ER_CANT_LOCK, ER_CANT_OPEN_FILE, ER_FILE_NOT_FOUND
    int ER_CANT_READ_DIR, ER_CANT_SET_WD, ER_CHECKREAD, ER_DISK_FULL, ER_DUP_KEY
    int ER_ERROR_ON_CLOSE, ER_ERROR_ON_READ, ER_ERROR_ON_RENAME, ER_ERROR_ON_WRITE
    int ER_FILE_USED, ER_FILSORT_ABORT, ER_FORM_NOT_FOUND, ER_GET_ERRNO, ER_ILLEGAL_HA
    int ER_KEY_NOT_FOUND, ER_NOT_FORM_FILE, ER_NOT_KEYFILE, ER_OLD_KEYFILE
    int ER_OPEN_AS_READONLY, ER_OUTOFMEMORY, ER_OUT_OF_SORTMEMORY, ER_UNEXPECTED_EOF
    int ER_CON_COUNT_ERROR, ER_OUT_OF_RESOURCES, ER_BAD_HOST_ERROR, ER_HANDSHAKE_ERROR
    int ER_DBACCESS_DENIED_ERROR, ER_ACCESS_DENIED_ERROR, ER_NO_DB_ERROR, ER_UNKNOWN_COM_ERROR
    int ER_BAD_NULL_ERROR, ER_BAD_DB_ERROR, ER_TABLE_EXISTS_ERROR, ER_BAD_TABLE_ERROR
    int ER_NON_UNIQ_ERROR, ER_SERVER_SHUTDOWN, ER_BAD_FIELD_ERROR, ER_WRONG_FIELD_WITH_GROUP
    int ER_WRONG_GROUP_FIELD, ER_WRONG_SUM_SELECT, ER_WRONG_VALUE_COUNT, ER_TOO_LONG_IDENT
    int ER_DUP_FIELDNAME, ER_DUP_KEYNAME, ER_DUP_ENTRY, ER_WRONG_FIELD_SPEC, ER_PARSE_ERROR
    int ER_EMPTY_QUERY, ER_NONUNIQ_TABLE, ER_INVALID_DEFAULT, ER_MULTIPLE_PRI_KEY
    int ER_TOO_MANY_KEYS, ER_TOO_MANY_KEY_PARTS, ER_TOO_LONG_KEY, ER_KEY_COLUMN_DOES_NOT_EXITS
    int ER_BLOB_USED_AS_KEY, ER_TOO_BIG_FIELDLENGTH, ER_WRONG_AUTO_KEY, ER_READY
    int ER_NORMAL_SHUTDOWN, ER_GOT_SIGNAL, ER_SHUTDOWN_COMPLETE, ER_FORCING_CLOSE
    int ER_IPSOCK_ERROR, ER_NO_SUCH_INDEX, ER_WRONG_FIELD_TERMINATORS, ER_BLOBS_AND_NO_TERMINATED
    int ER_TEXTFILE_NOT_READABLE, ER_FILE_EXISTS_ERROR, ER_LOAD_INFO, ER_ALTER_INFO
    int ER_WRONG_SUB_KEY, ER_CANT_REMOVE_ALL_FIELDS, ER_CANT_DROP_FIELD_OR_KEY, ER_INSERT_INFO
    int ER_UPDATE_TABLE_USED, ER_NO_SUCH_THREAD, ER_KILL_DENIED_ERROR, ER_NO_TABLES_USED
    int ER_TOO_BIG_SET, ER_NO_UNIQUE_LOGFILE, ER_TABLE_NOT_LOCKED_FOR_WRITE, ER_TABLE_NOT_LOCKED
    int ER_BLOB_CANT_HAVE_DEFAULT, ER_WRONG_DB_NAME, ER_WRONG_TABLE_NAME, ER_TOO_BIG_SELECT
    int ER_UNKNOWN_ERROR, ER_UNKNOWN_PROCEDURE, ER_WRONG_PARAMCOUNT_TO_PROCEDURE
    int ER_WRONG_PARAMETERS_TO_PROCEDURE, ER_UNKNOWN_TABLE, ER_FIELD_SPECIFIED_TWICE
    int ER_INVALID_GROUP_FUNC_USE, ER_UNSUPPORTED_EXTENSION, ER_TABLE_MUST_HAVE_COLUMNS
    int ER_RECORD_FILE_FULL, ER_UNKNOWN_CHARACTER_SET, ER_TOO_MANY_TABLES, ER_TOO_MANY_FIELDS
    int ER_TOO_BIG_ROWSIZE, ER_STACK_OVERRUN, ER_WRONG_OUTER_JOIN, ER_NULL_COLUMN_IN_INDEX
    int ER_CANT_FIND_UDF, ER_CANT_INITIALIZE_UDF, ER_UDF_NO_PATHS, ER_UDF_EXISTS
    int ER_CANT_OPEN_LIBRARY, ER_CANT_FIND_DL_ENTRY, ER_FUNCTION_NOT_DEFINED, ER_HOST_IS_BLOCKED
    int ER_HOST_NOT_PRIVILEGED, ER_PASSWORD_ANONYMOUS_USER, ER_PASSWORD_NOT_ALLOWED
    int ER_PASSWORD_NO_MATCH, ER_UPDATE_INFO, ER_CANT_CREATE_THREAD, ER_WRONG_VALUE_COUNT_ON_ROW
    int ER_CANT_REOPEN_TABLE, ER_INVALID_USE_OF_NULL, ER_REGEXP_ERROR, ER_MIX_OF_GROUP_FUNC_AND_FIELDS
    int ER_NONEXISTING_GRANT, ER_TABLEACCESS_DENIED_ERROR, ER_COLUMNACCESS_DENIED_ERROR
    int ER_ILLEGAL_GRANT_FOR_TABLE, ER_GRANT_WRONG_HOST_OR_USER, ER_NO_SUCH_TABLE
    int ER_NONEXISTING_TABLE_GRANT, ER_NOT_ALLOWED_COMMAND, ER_SYNTAX_ERROR
    int ER_DELAYED_CANT_CHANGE_LOCK, ER_TOO_MANY_DELAYED_THREADS, ER_ABORTING_CONNECTION
    int ER_NET_PACKET_TOO_LARGE, ER_NET_READ_ERROR_FROM_PIPE, ER_NET_FCNTL_ERROR
    int ER_NET_PACKETS_OUT_OF_ORDER, ER_NET_UNCOMPRESS_ERROR, ER_NET_READ_ERROR
    int ER_NET_READ_INTERRUPTED, ER_NET_ERROR_ON_WRITE, ER_NET_WRITE_INTERRUPTED
    int ER_TOO_LONG_STRING, ER_TABLE_CANT_HANDLE_BLOB, ER_TABLE_CANT_HANDLE_AUTO_INCREMENT
    int ER_DELAYED_INSERT_TABLE_LOCKED, ER_WRONG_COLUMN_NAME, ER_WRONG_KEY_COLUMN
    int ER_WRONG_MRG_TABLE, ER_DUP_UNIQUE, ER_BLOB_KEY_WITHOUT_LENGTH, ER_PRIMARY_CANT_HAVE_NULL
    int ER_TOO_MANY_ROWS, ER_REQUIRES_PRIMARY_KEY, ER_NO_RAID_COMPILED
    int ER_UPDATE_WITHOUT_KEY_IN_SAFE_MODE, ER_KEY_DOES_NOT_EXITS, ER_CHECK_NO_SUCH_TABLE
    int ER_CHECK_NOT_IMPLEMENTED, ER_CANT_DO_THIS_DURING_AN_TRANSACTION, ER_ERROR_DURING_COMMIT
    int ER_ERROR_DURING_ROLLBACK, ER_ERROR_DURING_FLUSH_LOGS, ER_ERROR_DURING_CHECKPOINT
    int ER_NEW_ABORTING_CONNECTION, ER_DUMP_NOT_IMPLEMENTED, ER_FLUSH_MASTER_BINLOG_CLOSED
    int ER_INDEX_REBUILD, ER_MASTER, ER_MASTER_NET_READ, ER_MASTER_NET_WRITE
    int ER_FT_MATCHING_KEY_NOT_FOUND, ER_LOCK_OR_ACTIVE_TRANSACTION, ER_UNKNOWN_SYSTEM_VARIABLE
    int ER_CRASHED_ON_USAGE, ER_CRASHED_ON_REPAIR, ER_WARNING_NOT_COMPLETE_ROLLBACK
    int ER_TRANS_CACHE_FULL, ER_SLAVE_MUST_STOP, ER_SLAVE_NOT_RUNNING, ER_BAD_SLAVE
    int ER_MASTER_INFO, ER_SLAVE_THREAD, ER_TOO_MANY_USER_CONNECTIONS, ER_SET_CONSTANTS_ONLY
    int ER_LOCK_WAIT_TIMEOUT, ER_LOCK_TABLE_FULL, ER_READ_ONLY_TRANSACTION, ER_DROP_DB_WITH_READ_LOCK
    int ER_CREATE_DB_WITH_READ_LOCK, ER_WRONG_ARGUMENTS, ER_NO_PERMISSION_TO_CREATE_USER
    int ER_UNION_TABLES_IN_DIFFERENT_DIR, ER_LOCK_DEADLOCK, ER_TABLE_CANT_HANDLE_FT
    int ER_CANNOT_ADD_FOREIGN, ER_NO_REFERENCED_ROW, ER_ROW_IS_REFERENCED, ER_CONNECT_TO_MASTER
    int ER_QUERY_ON_MASTER, ER_ERROR_WHEN_EXECUTING_COMMAND, ER_WRONG_USAGE
    int ER_WRONG_NUMBER_OF_COLUMNS_IN_SELECT, ER_CANT_UPDATE_WITH_READLOCK, ER_MIXING_NOT_ALLOWED
    int ER_DUP_ARGUMENT, ER_USER_LIMIT_REACHED, ER_SPECIFIC_ACCESS_DENIED_ERROR
    int ER_LOCAL_VARIABLE, ER_GLOBAL_VARIABLE, ER_NO_DEFAULT, ER_WRONG_VALUE_FOR_VAR
    int ER_WRONG_TYPE_FOR_VAR, ER_VAR_CANT_BE_READ, ER_CANT_USE_OPTION_HERE, ER_NOT_SUPPORTED_YET
    int ER_MASTER_FATAL_ERROR_READING_BINLOG, ER_SLAVE_IGNORED_TABLE, ER_INCORRECT_GLOBAL_LOCAL_VAR
    int ER_WRONG_FK_DEF, ER_KEY_REF_DO_NOT_MATCH_TABLE_REF, ER_OPERAND_COLUMNS, ER_SUBQUERY_NO_1_ROW
    int ER_UNKNOWN_STMT_HANDLER, ER_CORRUPT_HELP_DB, ER_CYCLIC_REFERENCE, ER_AUTO_CONVERT
    int ER_ILLEGAL_REFERENCE, ER_DERIVED_MUST_HAVE_ALIAS, ER_SELECT_REDUCED
    int ER_TABLENAME_NOT_ALLOWED_HERE, ER_NOT_SUPPORTED_AUTH_MODE, ER_SPATIAL_CANT_HAVE_NULL
    int ER_COLLATION_CHARSET_MISMATCH, ER_SLAVE_WAS_RUNNING, ER_SLAVE_WAS_NOT_RUNNING
    int ER_TOO_BIG_FOR_UNCOMPRESS, ER_ZLIB_Z_MEM_ERROR, ER_ZLIB_Z_BUF_ERROR, ER_ZLIB_Z_DATA_ERROR
    int ER_CUT_VALUE_GROUP_CONCAT, ER_WARN_TOO_FEW_RECORDS, ER_WARN_TOO_MANY_RECORDS
    int ER_WARN_NULL_TO_NOTNULL, ER_WARN_DATA_OUT_OF_RANGE, ER_WARN_DATA_TRUNCATED
    int ER_WARN_USING_OTHER_HANDLER, ER_CANT_AGGREGATE_2COLLATIONS, ER_DROP_USER, ER_REVOKE_GRANTS
    int ER_CANT_AGGREGATE_3COLLATIONS, ER_CANT_AGGREGATE_NCOLLATIONS, ER_VARIABLE_IS_NOT_STRUCT
    int ER_UNKNOWN_COLLATION, ER_SLAVE_IGNORED_SSL_PARAMS, ER_SERVER_IS_IN_SECURE_AUTH_MODE
    int ER_WARN_FIELD_RESOLVED, ER_BAD_SLAVE_UNTIL_COND, ER_MISSING_SKIP_SLAVE, ER_UNTIL_COND_IGNORED
    int ER_WRONG_NAME_FOR_INDEX, ER_WRONG_NAME_FOR_CATALOG, ER_WARN_QC_RESIZE, ER_BAD_FT_COLUMN
    int ER_UNKNOWN_KEY_CACHE, ER_WARN_HOSTNAME_WONT_WORK, ER_UNKNOWN_STORAGE_ENGINE
    int ER_WARN_DEPRECATED_SYNTAX, ER_NON_UPDATABLE_TABLE, ER_FEATURE_DISABLED
    int ER_OPTION_PREVENTS_STATEMENT, ER_DUPLICATED_VALUE_IN_TYPE, ER_TRUNCATED_WRONG_VALUE
    int ER_TOO_MUCH_AUTO_TIMESTAMP_COLS, ER_INVALID_ON_UPDATE, ER_UNSUPPORTED_PS, ER_GET_ERRMSG
    int ER_GET_TEMPORARY_ERRMSG, ER_UNKNOWN_TIME_ZONE, ER_WARN_INVALID_TIMESTAMP
    int ER_INVALID_CHARACTER_STRING, ER_WARN_ALLOWED_PACKET_OVERFLOWED, ER_CONFLICTING_DECLARATIONS
    int ER_SP_NO_RECURSIVE_CREATE, ER_SP_ALREADY_EXISTS, ER_SP_DOES_NOT_EXIST, ER_SP_DROP_FAILED
    int ER_SP_STORE_FAILED, ER_SP_LILABEL_MISMATCH, ER_SP_LABEL_REDEFINE, ER_SP_LABEL_MISMATCH
    int ER_SP_UNINIT_VAR, ER_SP_BADSELECT, ER_SP_BADRETURN, ER_SP_BADSTATEMENT
    int ER_UPDATE_LOG_DEPRECATED_IGNORED, ER_UPDATE_LOG_DEPRECATED_TRANSLATED, ER_QUERY_INTERRUPTED
    int ER_SP_WRONG_NO_OF_ARGS, ER_SP_COND_MISMATCH, ER_SP_NORETURN, ER_SP_NORETURNEND
    int ER_SP_BAD_CURSOR_QUERY, ER_SP_BAD_CURSOR_SELECT, ER_SP_CURSOR_MISMATCH
    int ER_SP_CURSOR_ALREADY_OPEN, ER_SP_CURSOR_NOT_OPEN, ER_SP_UNDECLARED_VAR
    int ER_SP_WRONG_NO_OF_FETCH_ARGS, ER_SP_FETCH_NO_DATA, ER_SP_DUP_PARAM, ER_SP_DUP_VAR
    int ER_SP_DUP_COND, ER_SP_DUP_CURS, ER_SP_CANT_ALTER, ER_SP_SUBSELECT_NYI
    int ER_STMT_NOT_ALLOWED_IN_SF_OR_TRG, ER_SP_VARCOND_AFTER_CURSHNDLR, ER_SP_CURSOR_AFTER_HANDLER
    int ER_SP_CASE_NOT_FOUND, ER_FPARSER_TOO_BIG_FILE, ER_FPARSER_BAD_HEADER, ER_FPARSER_EOF_IN_COMMENT
    int ER_FPARSER_ERROR_IN_PARAMETER, ER_FPARSER_EOF_IN_UNKNOWN_PARAMETER, ER_VIEW_NO_EXPLAIN
    int ER_FRM_UNKNOWN_TYPE, ER_WRONG_OBJECT, ER_NONUPDATEABLE_COLUMN, ER_VIEW_SELECT_DERIVED
    int ER_VIEW_SELECT_CLAUSE, ER_VIEW_SELECT_VARIABLE, ER_VIEW_SELECT_TMPTABLE, ER_VIEW_WRONG_LIST
    int ER_WARN_VIEW_MERGE, ER_WARN_VIEW_WITHOUT_KEY, ER_VIEW_INVALID, ER_SP_NO_DROP_SP
    int ER_SP_GOTO_IN_HNDLR, ER_TRG_ALREADY_EXISTS, ER_TRG_DOES_NOT_EXIST, ER_TRG_ON_VIEW_OR_TEMP_TABLE
    int ER_TRG_CANT_CHANGE_ROW, ER_TRG_NO_SUCH_ROW_IN_TRG, ER_NO_DEFAULT_FOR_FIELD, ER_DIVISION_BY_ZERO
    int ER_TRUNCATED_WRONG_VALUE_FOR_FIELD, ER_ILLEGAL_VALUE_FOR_TYPE, ER_VIEW_NONUPD_CHECK
    int ER_VIEW_CHECK_FAILED, ER_PROCACCESS_DENIED_ERROR, ER_RELAY_LOG_FAIL, ER_PASSWD_LENGTH
    int ER_UNKNOWN_TARGET_BINLOG, ER_IO_ERR_LOG_INDEX_READ, ER_BINLOG_PURGE_PROHIBITED, ER_FSEEK_FAIL
    int ER_BINLOG_PURGE_FATAL_ERR, ER_LOG_IN_USE, ER_LOG_PURGE_UNKNOWN_ERR, ER_RELAY_LOG_INIT
    int ER_NO_BINARY_LOGGING, ER_RESERVED_SYNTAX, ER_WSAS_FAILED, ER_DIFF_GROUPS_PROC
    int ER_NO_GROUP_FOR_PROC, ER_ORDER_WITH_PROC, ER_LOGGING_PROHIBIT_CHANGING_OF, ER_NO_FILE_MAPPING
    int ER_WRONG_MAGIC, ER_PS_MANY_PARAM, ER_KEY_PART_0, ER_VIEW_CHECKSUM, ER_VIEW_MULTIUPDATE
    int ER_VIEW_NO_INSERT_FIELD_LIST, ER_VIEW_DELETE_MERGE_VIEW, ER_CANNOT_USER, ER_XAER_NOTA
    int ER_XAER_INVAL, ER_XAER_RMFAIL, ER_XAER_OUTSIDE, ER_XAER_RMERR, ER_XA_RBROLLBACK
    int ER_NONEXISTING_PROC_GRANT, ER_PROC_AUTO_GRANT_FAIL, ER_PROC_AUTO_REVOKE_FAIL, ER_DATA_TOO_LONG
    int ER_SP_BAD_SQLSTATE, ER_STARTUP, ER_LOAD_FROM_FIXED_SIZE_ROWS_TO_VAR
    int ER_CANT_CREATE_USER_WITH_GRANT, ER_WRONG_VALUE_FOR_TYPE, ER_TABLE_DEF_CHANGED, ER_SP_DUP_HANDLER
    int ER_SP_NOT_VAR_ARG, ER_SP_NO_RETSET, ER_CANT_CREATE_GEOMETRY_OBJECT, ER_FAILED_ROUTINE_BREAK_BINLOG
    int ER_BINLOG_UNSAFE_ROUTINE, ER_BINLOG_CREATE_ROUTINE_NEED_SUPER, ER_EXEC_STMT_WITH_OPEN_CURSOR
    int ER_STMT_HAS_NO_OPEN_CURSOR, ER_COMMIT_NOT_ALLOWED_IN_SF_OR_TRG, ER_NO_DEFAULT_FOR_VIEW_FIELD
    int ER_SP_NO_RECURSION, ER_TOO_BIG_SCALE, ER_TOO_BIG_PRECISION, ER_M_BIGGER_THAN_D
    int ER_WRONG_LOCK_OF_SYSTEM_TABLE, ER_CONNECT_TO_FOREIGN_DATA_SOURCE, ER_QUERY_ON_FOREIGN_DATA_SOURCE
    int ER_FOREIGN_DATA_SOURCE_DOESNT_EXIST, ER_FOREIGN_DATA_STRING_INVALID_CANT_CREATE
    int ER_FOREIGN_DATA_STRING_INVALID, ER_CANT_CREATE_FEDERATED_TABLE, ER_TRG_IN_WRONG_SCHEMA
    int ER_STACK_OVERRUN_NEED_MORE, ER_TOO_LONG_BODY, ER_WARN_CANT_DROP_DEFAULT_KEYCACHE
    int ER_TOO_BIG_DISPLAYWIDTH, ER_XAER_DUPID, ER_DATETIME_FUNCTION_OVERFLOW
    int ER_CANT_UPDATE_USED_TABLE_IN_SF_OR_TRG, ER_VIEW_PREVENT_UPDATE, ER_PS_NO_RECURSION
    int ER_SP_CANT_SET_AUTOCOMMIT, ER_MALFORMED_DEFINER, ER_VIEW_FRM_NO_USER, ER_VIEW_OTHER_USER
    int ER_NO_SUCH_USER, ER_FORBID_SCHEMA_CHANGE, ER_ROW_IS_REFERENCED_2, ER_NO_REFERENCED_ROW_2
    int ER_SP_BAD_VAR_SHADOW, ER_TRG_NO_DEFINER, ER_OLD_FILE_FORMAT, ER_SP_RECURSION_LIMIT
    int ER_SP_PROC_TABLE_CORRUPT, ER_SP_WRONG_NAME, ER_TABLE_NEEDS_UPGRADE, ER_SP_NO_AGGREGATE
    int ER_MAX_PREPARED_STMT_COUNT_REACHED, ER_VIEW_RECURSIVE, ER_NON_GROUPING_FIELD_USED
    int ER_TABLE_CANT_HANDLE_SPKEYS, ER_NO_TRIGGERS_ON_SYSTEM_SCHEMA, ER_USERNAME, ER_HOSTNAME
    int ER_WRONG_STRING_LENGTH, ER_ERROR_LAST, ER_STATEMENT_TIMEOUT, ER_QUERY_TIMEOUT
    int ER_CONSTRAINT_FAILED

# Field type
cdef:
    int FIELD_TYPE_DECIMAL, FIELD_TYPE_TINY, FIELD_TYPE_SHORT, FIELD_TYPE_LONG, FIELD_TYPE_FLOAT
    int FIELD_TYPE_DOUBLE, FIELD_TYPE_NULL, FIELD_TYPE_TIMESTAMP, FIELD_TYPE_LONGLONG
    int FIELD_TYPE_INT24, FIELD_TYPE_DATE, FIELD_TYPE_TIME, FIELD_TYPE_DATETIME, FIELD_TYPE_YEAR
    int FIELD_TYPE_NEWDATE, FIELD_TYPE_VARCHAR, FIELD_TYPE_BIT, FIELD_TYPE_JSON, FIELD_TYPE_NEWDECIMAL
    int FIELD_TYPE_ENUM, FIELD_TYPE_SET, FIELD_TYPE_TINY_BLOB, FIELD_TYPE_MEDIUM_BLOB
    int FIELD_TYPE_LONG_BLOB, FIELD_TYPE_BLOB, FIELD_TYPE_VAR_STRING, FIELD_TYPE_STRING
    int FIELD_TYPE_GEOMETRY, FIELD_TYPE_CHAR, FIELD_TYPE_INTERVAL
    set FIELD_TEXT_TYPES
    
# Flag
cdef:
    int FLAG_NOT_NULL, FLAG_PRI_KEY, FLAG_UNIQUE_KEY, FLAG_MULTIPLE_KEY, FLAG_BLOB, FLAG_UNSIGNED
    int FLAG_ZEROFILL, FLAG_BINARY, FLAG_ENUM, FLAG_AUTO_INCREMENT, FLAG_TIMESTAMP, FLAG_SET
    int FLAG_PART_KEY, FLAG_GROUP, FLAG_UNIQUE

# Server
cdef:
    int SERVER_STATUS_IN_TRANS, SERVER_STATUS_AUTOCOMMIT, SERVER_MORE_RESULTS_EXISTS
    int SERVER_QUERY_NO_GOOD_INDEX_USED, SERVER_QUERY_NO_INDEX_USED, SERVER_STATUS_CURSOR_EXISTS
    int SERVER_STATUS_LAST_ROW_SENT, SERVER_STATUS_DB_DROPPED, SERVER_STATUS_NO_BACKSLASH_ESCAPES
    int SERVER_STATUS_METADATA_CHANGED
