# cython: language_level=3

# Cython imports
import cython

# Client ===========================================================================
CLIENT_LONG_PASSWORD: cython.int = 1
CLIENT_FOUND_ROWS: cython.int = 1 << 1
CLIENT_LONG_FLAG: cython.int = 1 << 2
CLIENT_CONNECT_WITH_DB: cython.int = 1 << 3
CLIENT_NO_SCHEMA: cython.int = 1 << 4
CLIENT_COMPRESS: cython.int = 1 << 5
CLIENT_ODBC: cython.int = 1 << 6
CLIENT_LOCAL_FILES: cython.int = 1 << 7
CLIENT_IGNORE_SPACE: cython.int = 1 << 8
CLIENT_PROTOCOL_41: cython.int = 1 << 9
CLIENT_INTERACTIVE: cython.int = 1 << 10
CLIENT_SSL: cython.int = 1 << 11
CLIENT_IGNORE_SIGPIPE: cython.int = 1 << 12
CLIENT_TRANSACTIONS: cython.int = 1 << 13
CLIENT_SECURE_CONNECTION: cython.int = 1 << 15
CLIENT_MULTI_STATEMENTS: cython.int = 1 << 16
CLIENT_MULTI_RESULTS: cython.int = 1 << 17
CLIENT_PS_MULTI_RESULTS: cython.int = 1 << 18
CLIENT_PLUGIN_AUTH: cython.int = 1 << 19
CLIENT_CONNECT_ATTRS: cython.int = 1 << 20
CLIENT_PLUGIN_AUTH_LENENC_CLIENT_DATA: cython.int = 1 << 21
CLIENT_CAPABILITIES: cython.int = (
    CLIENT_LONG_PASSWORD
    | CLIENT_LONG_FLAG
    | CLIENT_PROTOCOL_41
    | CLIENT_TRANSACTIONS
    | CLIENT_SECURE_CONNECTION
    | CLIENT_MULTI_RESULTS
    | CLIENT_PLUGIN_AUTH
    | CLIENT_PLUGIN_AUTH_LENENC_CLIENT_DATA
    | CLIENT_CONNECT_ATTRS
)
# Not done yet
CLIENT_HANDLE_EXPIRED_PASSWORDS: cython.int = 1 << 22
CLIENT_SESSION_TRACK: cython.int = 1 << 23
CLIENT_DEPRECATE_EOF: cython.int = 1 << 24

# Command ==========================================================================
COM_SLEEP: cython.int = 0x00
COM_QUIT: cython.int = 0x01
COM_INIT_DB: cython.int = 0x02
COM_QUERY: cython.int = 0x03
COM_FIELD_LIST: cython.int = 0x04
COM_CREATE_DB: cython.int = 0x05
COM_DROP_DB: cython.int = 0x06
COM_REFRESH: cython.int = 0x07
COM_SHUTDOWN: cython.int = 0x08
COM_STATISTICS: cython.int = 0x09
COM_PROCESS_INFO: cython.int = 0x0A
COM_CONNECT: cython.int = 0x0B
COM_PROCESS_KILL: cython.int = 0x0C
COM_DEBUG: cython.int = 0x0D
COM_PING: cython.int = 0x0E
COM_TIME: cython.int = 0x0F
COM_DELAYED_INSERT: cython.int = 0x10
COM_CHANGE_USER: cython.int = 0x11
COM_BINLOG_DUMP: cython.int = 0x12
COM_TABLE_DUMP: cython.int = 0x13
COM_CONNECT_OUT: cython.int = 0x14
COM_REGISTER_SLAVE: cython.int = 0x15
COM_STMT_PREPARE: cython.int = 0x16
COM_STMT_EXECUTE: cython.int = 0x17
COM_STMT_SEND_LONG_DATA: cython.int = 0x18
COM_STMT_CLOSE: cython.int = 0x19
COM_STMT_RESET: cython.int = 0x1A
COM_SET_OPTION: cython.int = 0x1B
COM_STMT_FETCH: cython.int = 0x1C
COM_DAEMON: cython.int = 0x1D
COM_BINLOG_DUMP_GTID: cython.int = 0x1E
COM_END: cython.int = 0x1F

# CR ===============================================================================
CR_ERROR_FIRST: cython.int = 2000
CR_UNKNOWN_ERROR: cython.int = 2000
CR_SOCKET_CREATE_ERROR: cython.int = 2001
CR_CONNECTION_ERROR: cython.int = 2002
CR_CONN_HOST_ERROR: cython.int = 2003
CR_IPSOCK_ERROR: cython.int = 2004
CR_UNKNOWN_HOST: cython.int = 2005
CR_SERVER_GONE_ERROR: cython.int = 2006
CR_VERSION_ERROR: cython.int = 2007
CR_OUT_OF_MEMORY: cython.int = 2008
CR_WRONG_HOST_INFO: cython.int = 2009
CR_LOCALHOST_CONNECTION: cython.int = 2010
CR_TCP_CONNECTION: cython.int = 2011
CR_SERVER_HANDSHAKE_ERR: cython.int = 2012
CR_SERVER_LOST: cython.int = 2013
CR_COMMANDS_OUT_OF_SYNC: cython.int = 2014
CR_NAMEDPIPE_CONNECTION: cython.int = 2015
CR_NAMEDPIPEWAIT_ERROR: cython.int = 2016
CR_NAMEDPIPEOPEN_ERROR: cython.int = 2017
CR_NAMEDPIPESETSTATE_ERROR: cython.int = 2018
CR_CANT_READ_CHARSET: cython.int = 2019
CR_NET_PACKET_TOO_LARGE: cython.int = 2020
CR_EMBEDDED_CONNECTION: cython.int = 2021
CR_PROBE_SLAVE_STATUS: cython.int = 2022
CR_PROBE_SLAVE_HOSTS: cython.int = 2023
CR_PROBE_SLAVE_CONNECT: cython.int = 2024
CR_PROBE_MASTER_CONNECT: cython.int = 2025
CR_SSL_CONNECTION_ERROR: cython.int = 2026
CR_MALFORMED_PACKET: cython.int = 2027
CR_WRONG_LICENSE: cython.int = 2028
CR_NULL_POINTER: cython.int = 2029
CR_NO_PREPARE_STMT: cython.int = 2030
CR_PARAMS_NOT_BOUND: cython.int = 2031
CR_DATA_TRUNCATED: cython.int = 2032
CR_NO_PARAMETERS_EXISTS: cython.int = 2033
CR_INVALID_PARAMETER_NO: cython.int = 2034
CR_INVALID_BUFFER_USE: cython.int = 2035
CR_UNSUPPORTED_PARAM_TYPE: cython.int = 2036
CR_SHARED_MEMORY_CONNECTION: cython.int = 2037
CR_SHARED_MEMORY_CONNECT_REQUEST_ERROR: cython.int = 2038
CR_SHARED_MEMORY_CONNECT_ANSWER_ERROR: cython.int = 2039
CR_SHARED_MEMORY_CONNECT_FILE_MAP_ERROR: cython.int = 2040
CR_SHARED_MEMORY_CONNECT_MAP_ERROR: cython.int = 2041
CR_SHARED_MEMORY_FILE_MAP_ERROR: cython.int = 2042
CR_SHARED_MEMORY_MAP_ERROR: cython.int = 2043
CR_SHARED_MEMORY_EVENT_ERROR: cython.int = 2044
CR_SHARED_MEMORY_CONNECT_ABANDONED_ERROR: cython.int = 2045
CR_SHARED_MEMORY_CONNECT_SET_ERROR: cython.int = 2046
CR_CONN_UNKNOW_PROTOCOL: cython.int = 2047
CR_INVALID_CONN_HANDLE: cython.int = 2048
CR_SECURE_AUTH: cython.int = 2049
CR_FETCH_CANCELED: cython.int = 2050
CR_NO_DATA: cython.int = 2051
CR_NO_STMT_METADATA: cython.int = 2052
CR_NO_RESULT_SET: cython.int = 2053
CR_NOT_IMPLEMENTED: cython.int = 2054
CR_SERVER_LOST_EXTENDED: cython.int = 2055
CR_STMT_CLOSED: cython.int = 2056
CR_NEW_STMT_METADATA: cython.int = 2057
CR_ALREADY_CONNECTED: cython.int = 2058
CR_AUTH_PLUGIN_CANNOT_LOAD: cython.int = 2059
CR_DUPLICATE_CONNECTION_ATTR: cython.int = 2060
CR_AUTH_PLUGIN_ERR: cython.int = 2061
CR_INSECURE_API_ERR: cython.int = 2062
CR_FILE_NAME_TOO_LONG: cython.int = 2063
CR_SSL_FIPS_MODE_ERR: cython.int = 2064
CR_DEPRECATED_COMPRESSION_NOT_SUPPORTED: cython.int = 2065
CR_COMPRESSION_WRONGLY_CONFIGURED: cython.int = 2066
CR_KERBEROS_USER_NOT_FOUND: cython.int = 2067
CR_LOAD_DATA_LOCAL_INFILE_REJECTED: cython.int = 2068
CR_LOAD_DATA_LOCAL_INFILE_REALPATH_FAIL: cython.int = 2069
CR_DNS_SRV_LOOKUP_FAILED: cython.int = 2070
CR_MANDATORY_TRACKER_NOT_FOUND: cython.int = 2071
CR_INVALID_FACTOR_NO: cython.int = 2072
CR_ERROR_LAST: cython.int = 2072

# ER ===============================================================================
ER_ERROR_FIRST: cython.int = 1000
ER_HASHCHK: cython.int = 1000
ER_NISAMCHK: cython.int = 1001
ER_NO: cython.int = 1002
ER_YES: cython.int = 1003
ER_CANT_CREATE_FILE: cython.int = 1004
ER_CANT_CREATE_TABLE: cython.int = 1005
ER_CANT_CREATE_DB: cython.int = 1006
ER_DB_CREATE_EXISTS: cython.int = 1007
ER_DB_DROP_EXISTS: cython.int = 1008
ER_DB_DROP_DELETE: cython.int = 1009
ER_DB_DROP_RMDIR: cython.int = 1010
ER_CANT_DELETE_FILE: cython.int = 1011
ER_CANT_FIND_SYSTEM_REC: cython.int = 1012
ER_CANT_GET_STAT: cython.int = 1013
ER_CANT_GET_WD: cython.int = 1014
ER_CANT_LOCK: cython.int = 1015
ER_CANT_OPEN_FILE: cython.int = 1016
ER_FILE_NOT_FOUND: cython.int = 1017
ER_CANT_READ_DIR: cython.int = 1018
ER_CANT_SET_WD: cython.int = 1019
ER_CHECKREAD: cython.int = 1020
ER_DISK_FULL: cython.int = 1021
ER_DUP_KEY: cython.int = 1022
ER_ERROR_ON_CLOSE: cython.int = 1023
ER_ERROR_ON_READ: cython.int = 1024
ER_ERROR_ON_RENAME: cython.int = 1025
ER_ERROR_ON_WRITE: cython.int = 1026
ER_FILE_USED: cython.int = 1027
ER_FILSORT_ABORT: cython.int = 1028
ER_FORM_NOT_FOUND: cython.int = 1029
ER_GET_ERRNO: cython.int = 1030
ER_ILLEGAL_HA: cython.int = 1031
ER_KEY_NOT_FOUND: cython.int = 1032
ER_NOT_FORM_FILE: cython.int = 1033
ER_NOT_KEYFILE: cython.int = 1034
ER_OLD_KEYFILE: cython.int = 1035
ER_OPEN_AS_READONLY: cython.int = 1036
ER_OUTOFMEMORY: cython.int = 1037
ER_OUT_OF_SORTMEMORY: cython.int = 1038
ER_UNEXPECTED_EOF: cython.int = 1039
ER_CON_COUNT_ERROR: cython.int = 1040
ER_OUT_OF_RESOURCES: cython.int = 1041
ER_BAD_HOST_ERROR: cython.int = 1042
ER_HANDSHAKE_ERROR: cython.int = 1043
ER_DBACCESS_DENIED_ERROR: cython.int = 1044
ER_ACCESS_DENIED_ERROR: cython.int = 1045
ER_NO_DB_ERROR: cython.int = 1046
ER_UNKNOWN_COM_ERROR: cython.int = 1047
ER_BAD_NULL_ERROR: cython.int = 1048
ER_BAD_DB_ERROR: cython.int = 1049
ER_TABLE_EXISTS_ERROR: cython.int = 1050
ER_BAD_TABLE_ERROR: cython.int = 1051
ER_NON_UNIQ_ERROR: cython.int = 1052
ER_SERVER_SHUTDOWN: cython.int = 1053
ER_BAD_FIELD_ERROR: cython.int = 1054
ER_WRONG_FIELD_WITH_GROUP: cython.int = 1055
ER_WRONG_GROUP_FIELD: cython.int = 1056
ER_WRONG_SUM_SELECT: cython.int = 1057
ER_WRONG_VALUE_COUNT: cython.int = 1058
ER_TOO_LONG_IDENT: cython.int = 1059
ER_DUP_FIELDNAME: cython.int = 1060
ER_DUP_KEYNAME: cython.int = 1061
ER_DUP_ENTRY: cython.int = 1062
ER_WRONG_FIELD_SPEC: cython.int = 1063
ER_PARSE_ERROR: cython.int = 1064
ER_EMPTY_QUERY: cython.int = 1065
ER_NONUNIQ_TABLE: cython.int = 1066
ER_INVALID_DEFAULT: cython.int = 1067
ER_MULTIPLE_PRI_KEY: cython.int = 1068
ER_TOO_MANY_KEYS: cython.int = 1069
ER_TOO_MANY_KEY_PARTS: cython.int = 1070
ER_TOO_LONG_KEY: cython.int = 1071
ER_KEY_COLUMN_DOES_NOT_EXITS: cython.int = 1072
ER_BLOB_USED_AS_KEY: cython.int = 1073
ER_TOO_BIG_FIELDLENGTH: cython.int = 1074
ER_WRONG_AUTO_KEY: cython.int = 1075
ER_READY: cython.int = 1076
ER_NORMAL_SHUTDOWN: cython.int = 1077
ER_GOT_SIGNAL: cython.int = 1078
ER_SHUTDOWN_COMPLETE: cython.int = 1079
ER_FORCING_CLOSE: cython.int = 1080
ER_IPSOCK_ERROR: cython.int = 1081
ER_NO_SUCH_INDEX: cython.int = 1082
ER_WRONG_FIELD_TERMINATORS: cython.int = 1083
ER_BLOBS_AND_NO_TERMINATED: cython.int = 1084
ER_TEXTFILE_NOT_READABLE: cython.int = 1085
ER_FILE_EXISTS_ERROR: cython.int = 1086
ER_LOAD_INFO: cython.int = 1087
ER_ALTER_INFO: cython.int = 1088
ER_WRONG_SUB_KEY: cython.int = 1089
ER_CANT_REMOVE_ALL_FIELDS: cython.int = 1090
ER_CANT_DROP_FIELD_OR_KEY: cython.int = 1091
ER_INSERT_INFO: cython.int = 1092
ER_UPDATE_TABLE_USED: cython.int = 1093
ER_NO_SUCH_THREAD: cython.int = 1094
ER_KILL_DENIED_ERROR: cython.int = 1095
ER_NO_TABLES_USED: cython.int = 1096
ER_TOO_BIG_SET: cython.int = 1097
ER_NO_UNIQUE_LOGFILE: cython.int = 1098
ER_TABLE_NOT_LOCKED_FOR_WRITE: cython.int = 1099
ER_TABLE_NOT_LOCKED: cython.int = 1100
ER_BLOB_CANT_HAVE_DEFAULT: cython.int = 1101
ER_WRONG_DB_NAME: cython.int = 1102
ER_WRONG_TABLE_NAME: cython.int = 1103
ER_TOO_BIG_SELECT: cython.int = 1104
ER_UNKNOWN_ERROR: cython.int = 1105
ER_UNKNOWN_PROCEDURE: cython.int = 1106
ER_WRONG_PARAMCOUNT_TO_PROCEDURE: cython.int = 1107
ER_WRONG_PARAMETERS_TO_PROCEDURE: cython.int = 1108
ER_UNKNOWN_TABLE: cython.int = 1109
ER_FIELD_SPECIFIED_TWICE: cython.int = 1110
ER_INVALID_GROUP_FUNC_USE: cython.int = 1111
ER_UNSUPPORTED_EXTENSION: cython.int = 1112
ER_TABLE_MUST_HAVE_COLUMNS: cython.int = 1113
ER_RECORD_FILE_FULL: cython.int = 1114
ER_UNKNOWN_CHARACTER_SET: cython.int = 1115
ER_TOO_MANY_TABLES: cython.int = 1116
ER_TOO_MANY_FIELDS: cython.int = 1117
ER_TOO_BIG_ROWSIZE: cython.int = 1118
ER_STACK_OVERRUN: cython.int = 1119
ER_WRONG_OUTER_JOIN: cython.int = 1120
ER_NULL_COLUMN_IN_INDEX: cython.int = 1121
ER_CANT_FIND_UDF: cython.int = 1122
ER_CANT_INITIALIZE_UDF: cython.int = 1123
ER_UDF_NO_PATHS: cython.int = 1124
ER_UDF_EXISTS: cython.int = 1125
ER_CANT_OPEN_LIBRARY: cython.int = 1126
ER_CANT_FIND_DL_ENTRY: cython.int = 1127
ER_FUNCTION_NOT_DEFINED: cython.int = 1128
ER_HOST_IS_BLOCKED: cython.int = 1129
ER_HOST_NOT_PRIVILEGED: cython.int = 1130
ER_PASSWORD_ANONYMOUS_USER: cython.int = 1131
ER_PASSWORD_NOT_ALLOWED: cython.int = 1132
ER_PASSWORD_NO_MATCH: cython.int = 1133
ER_UPDATE_INFO: cython.int = 1134
ER_CANT_CREATE_THREAD: cython.int = 1135
ER_WRONG_VALUE_COUNT_ON_ROW: cython.int = 1136
ER_CANT_REOPEN_TABLE: cython.int = 1137
ER_INVALID_USE_OF_NULL: cython.int = 1138
ER_REGEXP_ERROR: cython.int = 1139
ER_MIX_OF_GROUP_FUNC_AND_FIELDS: cython.int = 1140
ER_NONEXISTING_GRANT: cython.int = 1141
ER_TABLEACCESS_DENIED_ERROR: cython.int = 1142
ER_COLUMNACCESS_DENIED_ERROR: cython.int = 1143
ER_ILLEGAL_GRANT_FOR_TABLE: cython.int = 1144
ER_GRANT_WRONG_HOST_OR_USER: cython.int = 1145
ER_NO_SUCH_TABLE: cython.int = 1146
ER_NONEXISTING_TABLE_GRANT: cython.int = 1147
ER_NOT_ALLOWED_COMMAND: cython.int = 1148
ER_SYNTAX_ERROR: cython.int = 1149
ER_DELAYED_CANT_CHANGE_LOCK: cython.int = 1150
ER_TOO_MANY_DELAYED_THREADS: cython.int = 1151
ER_ABORTING_CONNECTION: cython.int = 1152
ER_NET_PACKET_TOO_LARGE: cython.int = 1153
ER_NET_READ_ERROR_FROM_PIPE: cython.int = 1154
ER_NET_FCNTL_ERROR: cython.int = 1155
ER_NET_PACKETS_OUT_OF_ORDER: cython.int = 1156
ER_NET_UNCOMPRESS_ERROR: cython.int = 1157
ER_NET_READ_ERROR: cython.int = 1158
ER_NET_READ_INTERRUPTED: cython.int = 1159
ER_NET_ERROR_ON_WRITE: cython.int = 1160
ER_NET_WRITE_INTERRUPTED: cython.int = 1161
ER_TOO_LONG_STRING: cython.int = 1162
ER_TABLE_CANT_HANDLE_BLOB: cython.int = 1163
ER_TABLE_CANT_HANDLE_AUTO_INCREMENT: cython.int = 1164
ER_DELAYED_INSERT_TABLE_LOCKED: cython.int = 1165
ER_WRONG_COLUMN_NAME: cython.int = 1166
ER_WRONG_KEY_COLUMN: cython.int = 1167
ER_WRONG_MRG_TABLE: cython.int = 1168
ER_DUP_UNIQUE: cython.int = 1169
ER_BLOB_KEY_WITHOUT_LENGTH: cython.int = 1170
ER_PRIMARY_CANT_HAVE_NULL: cython.int = 1171
ER_TOO_MANY_ROWS: cython.int = 1172
ER_REQUIRES_PRIMARY_KEY: cython.int = 1173
ER_NO_RAID_COMPILED: cython.int = 1174
ER_UPDATE_WITHOUT_KEY_IN_SAFE_MODE: cython.int = 1175
ER_KEY_DOES_NOT_EXITS: cython.int = 1176
ER_CHECK_NO_SUCH_TABLE: cython.int = 1177
ER_CHECK_NOT_IMPLEMENTED: cython.int = 1178
ER_CANT_DO_THIS_DURING_AN_TRANSACTION: cython.int = 1179
ER_ERROR_DURING_COMMIT: cython.int = 1180
ER_ERROR_DURING_ROLLBACK: cython.int = 1181
ER_ERROR_DURING_FLUSH_LOGS: cython.int = 1182
ER_ERROR_DURING_CHECKPOINT: cython.int = 1183
ER_NEW_ABORTING_CONNECTION: cython.int = 1184
ER_DUMP_NOT_IMPLEMENTED: cython.int = 1185
ER_FLUSH_MASTER_BINLOG_CLOSED: cython.int = 1186
ER_INDEX_REBUILD: cython.int = 1187
ER_MASTER: cython.int = 1188
ER_MASTER_NET_READ: cython.int = 1189
ER_MASTER_NET_WRITE: cython.int = 1190
ER_FT_MATCHING_KEY_NOT_FOUND: cython.int = 1191
ER_LOCK_OR_ACTIVE_TRANSACTION: cython.int = 1192
ER_UNKNOWN_SYSTEM_VARIABLE: cython.int = 1193
ER_CRASHED_ON_USAGE: cython.int = 1194
ER_CRASHED_ON_REPAIR: cython.int = 1195
ER_WARNING_NOT_COMPLETE_ROLLBACK: cython.int = 1196
ER_TRANS_CACHE_FULL: cython.int = 1197
ER_SLAVE_MUST_STOP: cython.int = 1198
ER_SLAVE_NOT_RUNNING: cython.int = 1199
ER_BAD_SLAVE: cython.int = 1200
ER_MASTER_INFO: cython.int = 1201
ER_SLAVE_THREAD: cython.int = 1202
ER_TOO_MANY_USER_CONNECTIONS: cython.int = 1203
ER_SET_CONSTANTS_ONLY: cython.int = 1204
ER_LOCK_WAIT_TIMEOUT: cython.int = 1205
ER_LOCK_TABLE_FULL: cython.int = 1206
ER_READ_ONLY_TRANSACTION: cython.int = 1207
ER_DROP_DB_WITH_READ_LOCK: cython.int = 1208
ER_CREATE_DB_WITH_READ_LOCK: cython.int = 1209
ER_WRONG_ARGUMENTS: cython.int = 1210
ER_NO_PERMISSION_TO_CREATE_USER: cython.int = 1211
ER_UNION_TABLES_IN_DIFFERENT_DIR: cython.int = 1212
ER_LOCK_DEADLOCK: cython.int = 1213
ER_TABLE_CANT_HANDLE_FT: cython.int = 1214
ER_CANNOT_ADD_FOREIGN: cython.int = 1215
ER_NO_REFERENCED_ROW: cython.int = 1216
ER_ROW_IS_REFERENCED: cython.int = 1217
ER_CONNECT_TO_MASTER: cython.int = 1218
ER_QUERY_ON_MASTER: cython.int = 1219
ER_ERROR_WHEN_EXECUTING_COMMAND: cython.int = 1220
ER_WRONG_USAGE: cython.int = 1221
ER_WRONG_NUMBER_OF_COLUMNS_IN_SELECT: cython.int = 1222
ER_CANT_UPDATE_WITH_READLOCK: cython.int = 1223
ER_MIXING_NOT_ALLOWED: cython.int = 1224
ER_DUP_ARGUMENT: cython.int = 1225
ER_USER_LIMIT_REACHED: cython.int = 1226
ER_SPECIFIC_ACCESS_DENIED_ERROR: cython.int = 1227
ER_LOCAL_VARIABLE: cython.int = 1228
ER_GLOBAL_VARIABLE: cython.int = 1229
ER_NO_DEFAULT: cython.int = 1230
ER_WRONG_VALUE_FOR_VAR: cython.int = 1231
ER_WRONG_TYPE_FOR_VAR: cython.int = 1232
ER_VAR_CANT_BE_READ: cython.int = 1233
ER_CANT_USE_OPTION_HERE: cython.int = 1234
ER_NOT_SUPPORTED_YET: cython.int = 1235
ER_MASTER_FATAL_ERROR_READING_BINLOG: cython.int = 1236
ER_SLAVE_IGNORED_TABLE: cython.int = 1237
ER_INCORRECT_GLOBAL_LOCAL_VAR: cython.int = 1238
ER_WRONG_FK_DEF: cython.int = 1239
ER_KEY_REF_DO_NOT_MATCH_TABLE_REF: cython.int = 1240
ER_OPERAND_COLUMNS: cython.int = 1241
ER_SUBQUERY_NO_1_ROW: cython.int = 1242
ER_UNKNOWN_STMT_HANDLER: cython.int = 1243
ER_CORRUPT_HELP_DB: cython.int = 1244
ER_CYCLIC_REFERENCE: cython.int = 1245
ER_AUTO_CONVERT: cython.int = 1246
ER_ILLEGAL_REFERENCE: cython.int = 1247
ER_DERIVED_MUST_HAVE_ALIAS: cython.int = 1248
ER_SELECT_REDUCED: cython.int = 1249
ER_TABLENAME_NOT_ALLOWED_HERE: cython.int = 1250
ER_NOT_SUPPORTED_AUTH_MODE: cython.int = 1251
ER_SPATIAL_CANT_HAVE_NULL: cython.int = 1252
ER_COLLATION_CHARSET_MISMATCH: cython.int = 1253
ER_SLAVE_WAS_RUNNING: cython.int = 1254
ER_SLAVE_WAS_NOT_RUNNING: cython.int = 1255
ER_TOO_BIG_FOR_UNCOMPRESS: cython.int = 1256
ER_ZLIB_Z_MEM_ERROR: cython.int = 1257
ER_ZLIB_Z_BUF_ERROR: cython.int = 1258
ER_ZLIB_Z_DATA_ERROR: cython.int = 1259
ER_CUT_VALUE_GROUP_CONCAT: cython.int = 1260
ER_WARN_TOO_FEW_RECORDS: cython.int = 1261
ER_WARN_TOO_MANY_RECORDS: cython.int = 1262
ER_WARN_NULL_TO_NOTNULL: cython.int = 1263
ER_WARN_DATA_OUT_OF_RANGE: cython.int = 1264
ER_WARN_DATA_TRUNCATED: cython.int = 1265
ER_WARN_USING_OTHER_HANDLER: cython.int = 1266
ER_CANT_AGGREGATE_2COLLATIONS: cython.int = 1267
ER_DROP_USER: cython.int = 1268
ER_REVOKE_GRANTS: cython.int = 1269
ER_CANT_AGGREGATE_3COLLATIONS: cython.int = 1270
ER_CANT_AGGREGATE_NCOLLATIONS: cython.int = 1271
ER_VARIABLE_IS_NOT_STRUCT: cython.int = 1272
ER_UNKNOWN_COLLATION: cython.int = 1273
ER_SLAVE_IGNORED_SSL_PARAMS: cython.int = 1274
ER_SERVER_IS_IN_SECURE_AUTH_MODE: cython.int = 1275
ER_WARN_FIELD_RESOLVED: cython.int = 1276
ER_BAD_SLAVE_UNTIL_COND: cython.int = 1277
ER_MISSING_SKIP_SLAVE: cython.int = 1278
ER_UNTIL_COND_IGNORED: cython.int = 1279
ER_WRONG_NAME_FOR_INDEX: cython.int = 1280
ER_WRONG_NAME_FOR_CATALOG: cython.int = 1281
ER_WARN_QC_RESIZE: cython.int = 1282
ER_BAD_FT_COLUMN: cython.int = 1283
ER_UNKNOWN_KEY_CACHE: cython.int = 1284
ER_WARN_HOSTNAME_WONT_WORK: cython.int = 1285
ER_UNKNOWN_STORAGE_ENGINE: cython.int = 1286
ER_WARN_DEPRECATED_SYNTAX: cython.int = 1287
ER_NON_UPDATABLE_TABLE: cython.int = 1288
ER_FEATURE_DISABLED: cython.int = 1289
ER_OPTION_PREVENTS_STATEMENT: cython.int = 1290
ER_DUPLICATED_VALUE_IN_TYPE: cython.int = 1291
ER_TRUNCATED_WRONG_VALUE: cython.int = 1292
ER_TOO_MUCH_AUTO_TIMESTAMP_COLS: cython.int = 1293
ER_INVALID_ON_UPDATE: cython.int = 1294
ER_UNSUPPORTED_PS: cython.int = 1295
ER_GET_ERRMSG: cython.int = 1296
ER_GET_TEMPORARY_ERRMSG: cython.int = 1297
ER_UNKNOWN_TIME_ZONE: cython.int = 1298
ER_WARN_INVALID_TIMESTAMP: cython.int = 1299
ER_INVALID_CHARACTER_STRING: cython.int = 1300
ER_WARN_ALLOWED_PACKET_OVERFLOWED: cython.int = 1301
ER_CONFLICTING_DECLARATIONS: cython.int = 1302
ER_SP_NO_RECURSIVE_CREATE: cython.int = 1303
ER_SP_ALREADY_EXISTS: cython.int = 1304
ER_SP_DOES_NOT_EXIST: cython.int = 1305
ER_SP_DROP_FAILED: cython.int = 1306
ER_SP_STORE_FAILED: cython.int = 1307
ER_SP_LILABEL_MISMATCH: cython.int = 1308
ER_SP_LABEL_REDEFINE: cython.int = 1309
ER_SP_LABEL_MISMATCH: cython.int = 1310
ER_SP_UNINIT_VAR: cython.int = 1311
ER_SP_BADSELECT: cython.int = 1312
ER_SP_BADRETURN: cython.int = 1313
ER_SP_BADSTATEMENT: cython.int = 1314
ER_UPDATE_LOG_DEPRECATED_IGNORED: cython.int = 1315
ER_UPDATE_LOG_DEPRECATED_TRANSLATED: cython.int = 1316
ER_QUERY_INTERRUPTED: cython.int = 1317
ER_SP_WRONG_NO_OF_ARGS: cython.int = 1318
ER_SP_COND_MISMATCH: cython.int = 1319
ER_SP_NORETURN: cython.int = 1320
ER_SP_NORETURNEND: cython.int = 1321
ER_SP_BAD_CURSOR_QUERY: cython.int = 1322
ER_SP_BAD_CURSOR_SELECT: cython.int = 1323
ER_SP_CURSOR_MISMATCH: cython.int = 1324
ER_SP_CURSOR_ALREADY_OPEN: cython.int = 1325
ER_SP_CURSOR_NOT_OPEN: cython.int = 1326
ER_SP_UNDECLARED_VAR: cython.int = 1327
ER_SP_WRONG_NO_OF_FETCH_ARGS: cython.int = 1328
ER_SP_FETCH_NO_DATA: cython.int = 1329
ER_SP_DUP_PARAM: cython.int = 1330
ER_SP_DUP_VAR: cython.int = 1331
ER_SP_DUP_COND: cython.int = 1332
ER_SP_DUP_CURS: cython.int = 1333
ER_SP_CANT_ALTER: cython.int = 1334
ER_SP_SUBSELECT_NYI: cython.int = 1335
ER_STMT_NOT_ALLOWED_IN_SF_OR_TRG: cython.int = 1336
ER_SP_VARCOND_AFTER_CURSHNDLR: cython.int = 1337
ER_SP_CURSOR_AFTER_HANDLER: cython.int = 1338
ER_SP_CASE_NOT_FOUND: cython.int = 1339
ER_FPARSER_TOO_BIG_FILE: cython.int = 1340
ER_FPARSER_BAD_HEADER: cython.int = 1341
ER_FPARSER_EOF_IN_COMMENT: cython.int = 1342
ER_FPARSER_ERROR_IN_PARAMETER: cython.int = 1343
ER_FPARSER_EOF_IN_UNKNOWN_PARAMETER: cython.int = 1344
ER_VIEW_NO_EXPLAIN: cython.int = 1345
ER_FRM_UNKNOWN_TYPE: cython.int = 1346
ER_WRONG_OBJECT: cython.int = 1347
ER_NONUPDATEABLE_COLUMN: cython.int = 1348
ER_VIEW_SELECT_DERIVED: cython.int = 1349
ER_VIEW_SELECT_CLAUSE: cython.int = 1350
ER_VIEW_SELECT_VARIABLE: cython.int = 1351
ER_VIEW_SELECT_TMPTABLE: cython.int = 1352
ER_VIEW_WRONG_LIST: cython.int = 1353
ER_WARN_VIEW_MERGE: cython.int = 1354
ER_WARN_VIEW_WITHOUT_KEY: cython.int = 1355
ER_VIEW_INVALID: cython.int = 1356
ER_SP_NO_DROP_SP: cython.int = 1357
ER_SP_GOTO_IN_HNDLR: cython.int = 1358
ER_TRG_ALREADY_EXISTS: cython.int = 1359
ER_TRG_DOES_NOT_EXIST: cython.int = 1360
ER_TRG_ON_VIEW_OR_TEMP_TABLE: cython.int = 1361
ER_TRG_CANT_CHANGE_ROW: cython.int = 1362
ER_TRG_NO_SUCH_ROW_IN_TRG: cython.int = 1363
ER_NO_DEFAULT_FOR_FIELD: cython.int = 1364
ER_DIVISION_BY_ZERO: cython.int = 1365
ER_TRUNCATED_WRONG_VALUE_FOR_FIELD: cython.int = 1366
ER_ILLEGAL_VALUE_FOR_TYPE: cython.int = 1367
ER_VIEW_NONUPD_CHECK: cython.int = 1368
ER_VIEW_CHECK_FAILED: cython.int = 1369
ER_PROCACCESS_DENIED_ERROR: cython.int = 1370
ER_RELAY_LOG_FAIL: cython.int = 1371
ER_PASSWD_LENGTH: cython.int = 1372
ER_UNKNOWN_TARGET_BINLOG: cython.int = 1373
ER_IO_ERR_LOG_INDEX_READ: cython.int = 1374
ER_BINLOG_PURGE_PROHIBITED: cython.int = 1375
ER_FSEEK_FAIL: cython.int = 1376
ER_BINLOG_PURGE_FATAL_ERR: cython.int = 1377
ER_LOG_IN_USE: cython.int = 1378
ER_LOG_PURGE_UNKNOWN_ERR: cython.int = 1379
ER_RELAY_LOG_INIT: cython.int = 1380
ER_NO_BINARY_LOGGING: cython.int = 1381
ER_RESERVED_SYNTAX: cython.int = 1382
ER_WSAS_FAILED: cython.int = 1383
ER_DIFF_GROUPS_PROC: cython.int = 1384
ER_NO_GROUP_FOR_PROC: cython.int = 1385
ER_ORDER_WITH_PROC: cython.int = 1386
ER_LOGGING_PROHIBIT_CHANGING_OF: cython.int = 1387
ER_NO_FILE_MAPPING: cython.int = 1388
ER_WRONG_MAGIC: cython.int = 1389
ER_PS_MANY_PARAM: cython.int = 1390
ER_KEY_PART_0: cython.int = 1391
ER_VIEW_CHECKSUM: cython.int = 1392
ER_VIEW_MULTIUPDATE: cython.int = 1393
ER_VIEW_NO_INSERT_FIELD_LIST: cython.int = 1394
ER_VIEW_DELETE_MERGE_VIEW: cython.int = 1395
ER_CANNOT_USER: cython.int = 1396
ER_XAER_NOTA: cython.int = 1397
ER_XAER_INVAL: cython.int = 1398
ER_XAER_RMFAIL: cython.int = 1399
ER_XAER_OUTSIDE: cython.int = 1400
ER_XAER_RMERR: cython.int = 1401
ER_XA_RBROLLBACK: cython.int = 1402
ER_NONEXISTING_PROC_GRANT: cython.int = 1403
ER_PROC_AUTO_GRANT_FAIL: cython.int = 1404
ER_PROC_AUTO_REVOKE_FAIL: cython.int = 1405
ER_DATA_TOO_LONG: cython.int = 1406
ER_SP_BAD_SQLSTATE: cython.int = 1407
ER_STARTUP: cython.int = 1408
ER_LOAD_FROM_FIXED_SIZE_ROWS_TO_VAR: cython.int = 1409
ER_CANT_CREATE_USER_WITH_GRANT: cython.int = 1410
ER_WRONG_VALUE_FOR_TYPE: cython.int = 1411
ER_TABLE_DEF_CHANGED: cython.int = 1412
ER_SP_DUP_HANDLER: cython.int = 1413
ER_SP_NOT_VAR_ARG: cython.int = 1414
ER_SP_NO_RETSET: cython.int = 1415
ER_CANT_CREATE_GEOMETRY_OBJECT: cython.int = 1416
ER_FAILED_ROUTINE_BREAK_BINLOG: cython.int = 1417
ER_BINLOG_UNSAFE_ROUTINE: cython.int = 1418
ER_BINLOG_CREATE_ROUTINE_NEED_SUPER: cython.int = 1419
ER_EXEC_STMT_WITH_OPEN_CURSOR: cython.int = 1420
ER_STMT_HAS_NO_OPEN_CURSOR: cython.int = 1421
ER_COMMIT_NOT_ALLOWED_IN_SF_OR_TRG: cython.int = 1422
ER_NO_DEFAULT_FOR_VIEW_FIELD: cython.int = 1423
ER_SP_NO_RECURSION: cython.int = 1424
ER_TOO_BIG_SCALE: cython.int = 1425
ER_TOO_BIG_PRECISION: cython.int = 1426
ER_M_BIGGER_THAN_D: cython.int = 1427
ER_WRONG_LOCK_OF_SYSTEM_TABLE: cython.int = 1428
ER_CONNECT_TO_FOREIGN_DATA_SOURCE: cython.int = 1429
ER_QUERY_ON_FOREIGN_DATA_SOURCE: cython.int = 1430
ER_FOREIGN_DATA_SOURCE_DOESNT_EXIST: cython.int = 1431
ER_FOREIGN_DATA_STRING_INVALID_CANT_CREATE: cython.int = 1432
ER_FOREIGN_DATA_STRING_INVALID: cython.int = 1433
ER_CANT_CREATE_FEDERATED_TABLE: cython.int = 1434
ER_TRG_IN_WRONG_SCHEMA: cython.int = 1435
ER_STACK_OVERRUN_NEED_MORE: cython.int = 1436
ER_TOO_LONG_BODY: cython.int = 1437
ER_WARN_CANT_DROP_DEFAULT_KEYCACHE: cython.int = 1438
ER_TOO_BIG_DISPLAYWIDTH: cython.int = 1439
ER_XAER_DUPID: cython.int = 1440
ER_DATETIME_FUNCTION_OVERFLOW: cython.int = 1441
ER_CANT_UPDATE_USED_TABLE_IN_SF_OR_TRG: cython.int = 1442
ER_VIEW_PREVENT_UPDATE: cython.int = 1443
ER_PS_NO_RECURSION: cython.int = 1444
ER_SP_CANT_SET_AUTOCOMMIT: cython.int = 1445
ER_MALFORMED_DEFINER: cython.int = 1446
ER_VIEW_FRM_NO_USER: cython.int = 1447
ER_VIEW_OTHER_USER: cython.int = 1448
ER_NO_SUCH_USER: cython.int = 1449
ER_FORBID_SCHEMA_CHANGE: cython.int = 1450
ER_ROW_IS_REFERENCED_2: cython.int = 1451
ER_NO_REFERENCED_ROW_2: cython.int = 1452
ER_SP_BAD_VAR_SHADOW: cython.int = 1453
ER_TRG_NO_DEFINER: cython.int = 1454
ER_OLD_FILE_FORMAT: cython.int = 1455
ER_SP_RECURSION_LIMIT: cython.int = 1456
ER_SP_PROC_TABLE_CORRUPT: cython.int = 1457
ER_SP_WRONG_NAME: cython.int = 1458
ER_TABLE_NEEDS_UPGRADE: cython.int = 1459
ER_SP_NO_AGGREGATE: cython.int = 1460
ER_MAX_PREPARED_STMT_COUNT_REACHED: cython.int = 1461
ER_VIEW_RECURSIVE: cython.int = 1462
ER_NON_GROUPING_FIELD_USED: cython.int = 1463
ER_TABLE_CANT_HANDLE_SPKEYS: cython.int = 1464
ER_NO_TRIGGERS_ON_SYSTEM_SCHEMA: cython.int = 1465
ER_USERNAME: cython.int = 1466
ER_HOSTNAME: cython.int = 1467
ER_WRONG_STRING_LENGTH: cython.int = 1468
ER_ERROR_LAST: cython.int = 1468
# MariaDB only
ER_STATEMENT_TIMEOUT: cython.int = 1969
ER_QUERY_TIMEOUT: cython.int = 3024
# https://github.com/PyMySQL/PyMySQL/issues/607
ER_CONSTRAINT_FAILED: cython.int = 4025

# Field type =======================================================================
FIELD_TYPE_DECIMAL: cython.int = 0
FIELD_TYPE_TINY: cython.int = 1
FIELD_TYPE_SHORT: cython.int = 2
FIELD_TYPE_LONG: cython.int = 3
FIELD_TYPE_FLOAT: cython.int = 4
FIELD_TYPE_DOUBLE: cython.int = 5
FIELD_TYPE_NULL: cython.int = 6
FIELD_TYPE_TIMESTAMP: cython.int = 7
FIELD_TYPE_LONGLONG: cython.int = 8
FIELD_TYPE_INT24: cython.int = 9
FIELD_TYPE_DATE: cython.int = 10
FIELD_TYPE_TIME: cython.int = 11
FIELD_TYPE_DATETIME: cython.int = 12
FIELD_TYPE_YEAR: cython.int = 13
FIELD_TYPE_NEWDATE: cython.int = 14
FIELD_TYPE_VARCHAR: cython.int = 15
FIELD_TYPE_BIT: cython.int = 16
FIELD_TYPE_JSON: cython.int = 245
FIELD_TYPE_NEWDECIMAL: cython.int = 246
FIELD_TYPE_ENUM: cython.int = 247
FIELD_TYPE_SET: cython.int = 248
FIELD_TYPE_TINY_BLOB: cython.int = 249
FIELD_TYPE_MEDIUM_BLOB: cython.int = 250
FIELD_TYPE_LONG_BLOB: cython.int = 251
FIELD_TYPE_BLOB: cython.int = 252
FIELD_TYPE_VAR_STRING: cython.int = 253
FIELD_TYPE_STRING: cython.int = 254
FIELD_TYPE_GEOMETRY: cython.int = 255
FIELD_TYPE_CHAR: cython.int = FIELD_TYPE_TINY
FIELD_TYPE_INTERVAL: cython.int = FIELD_TYPE_ENUM
FIELD_TEXT_TYPES: set = {
    FIELD_TYPE_BIT,
    FIELD_TYPE_BLOB,
    FIELD_TYPE_LONG_BLOB,
    FIELD_TYPE_MEDIUM_BLOB,
    FIELD_TYPE_STRING,
    FIELD_TYPE_TINY_BLOB,
    FIELD_TYPE_VAR_STRING,
    FIELD_TYPE_VARCHAR,
    FIELD_TYPE_GEOMETRY,
}

# Flag =============================================================================
FLAG_NOT_NULL: cython.int = 1
FLAG_PRI_KEY: cython.int = 2
FLAG_UNIQUE_KEY: cython.int = 4
FLAG_MULTIPLE_KEY: cython.int = 8
FLAG_BLOB: cython.int = 16
FLAG_UNSIGNED: cython.int = 32
FLAG_ZEROFILL: cython.int = 64
FLAG_BINARY: cython.int = 128
FLAG_ENUM: cython.int = 256
FLAG_AUTO_INCREMENT: cython.int = 512
FLAG_TIMESTAMP: cython.int = 1024
FLAG_SET: cython.int = 2048
FLAG_PART_KEY: cython.int = 16384
FLAG_GROUP: cython.int = 32767
FLAG_UNIQUE: cython.int = 65536

# Server ===========================================================================
SERVER_STATUS_IN_TRANS: cython.int = 1
SERVER_STATUS_AUTOCOMMIT: cython.int = 2
SERVER_MORE_RESULTS_EXISTS: cython.int = 8
SERVER_QUERY_NO_GOOD_INDEX_USED: cython.int = 16
SERVER_QUERY_NO_INDEX_USED: cython.int = 32
SERVER_STATUS_CURSOR_EXISTS: cython.int = 64
SERVER_STATUS_LAST_ROW_SENT: cython.int = 128
SERVER_STATUS_DB_DROPPED: cython.int = 256
SERVER_STATUS_NO_BACKSLASH_ESCAPES: cython.int = 512
SERVER_STATUS_METADATA_CHANGED: cython.int = 1024
